



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C语言学习笔记--多维数组和多维指针</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C语言学习笔记--多维数组和多维指针</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-12 08:54:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>1. 指向指针的指针</h1>
<p>(1)指针的本质是变量,会占用一定的内存空间</p>
<p>(2)可以定义指针的指针来保存指针变量的地址值</p>
<p>(3)指针是个变量,同样也存在传值调用与传址调用</p>
<p>重置动态空间的大小</p>
<div>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;<br />
#include &lt;malloc.h&gt;

int reset(char**p,int size,int new_size)<br />
{<br />
    int ret = ;<br />
    int i = ;<br />
    int len = ;<br />
    char* pt = NULL;<br />
    char* pp = *p;

    if((p != NULL)&amp;&amp;(new_size &gt; ))<br />
    {<br />
        pt = (char*)malloc(new_size);

        len = (size &lt; new_size)?size : new_size;//取较小者

        //复制原内容<br />
        for(i=; i&lt;len;i++){<br />
            *pt = *pp++;<br />
        }

        free(*p); //释放原空间<br />
        *p = pt;  //*p指针指向新空间<br />
    }<br />
    else<br />
    {<br />
      ret = ;<br />
    }

    return ret;<br />
}

int main(int argc,char* argv[], char* env[])<br />
{

    char*p =(char*)malloc();

    printf("%p\n", p);//重置前二维数组的内存地址

    //重置大小后二维数组的内存地址<br />
    //因为重置后的内存地址可以是新的地址，所以这里<br />
    //需传入p指针的地址，以便在reset函数内部改变p，让<br />
    //p指向新的地址。<br />
    if (reset(&amp;p, , ))<br />
    {<br />
        printf("%p\n", p);<br />
    }

    free(p);<br />
    return ;<br />
}</pre>
</div>
<h1>2.二维数组与二级指针</h1>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/708332/201609/708332-20160926090902469-1137979452.png" /></p>
<p>(1)二维数组在内存中以一维的方式排布</p>
<p>(2)二维灵敏组中的第一维是一维数组</p>
<p>(3)二维数组中的第二维才是具体的值</p>
<p>(4)二维数组的数组名可看做常量指针</p>
<div>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;

//以一维数组的方式来遍历二维数组<br />
void printfArray(int a[],int size)<br />
{<br />
    int i = ;

    printf("printfArray:%d\n",sizeof(a)); //退化为指针

    for(i=; i&lt;size; i++)<br />
    {<br />
        printf("%d\n",a[i]);<br />
    }<br />
}

int main(int argc,char* argv[], char* env[])<br />
{<br />
    int a[][] = {{, , },{, , },{, , }};<br />
    int* p = &amp;a[][];//指向a[0][0]元素

    int i;<br />
    int j;

    for(i = ;i &lt; ; i++)<br />
    {<br />
        for(j = ;j &lt; ;j++)<br />
        {<br />
            printf("%d, ",*(*(a + i) + j));//以指针方式访问元素<br />
        }

        printf("\n");<br />
    }

    printf("\n");

    printfArray(p,);//以一维数组的方式访问二维数组

    return ;<br />
}</pre>
</div>
<h1>3. 数组名</h1>
<p>(1)一维数组名代表数组首元素的地址:int a[5];a 的类型为 int*</p>
<p>(2)二维数组名同样代表数组首元素的地址:如 int a[3][5],a 的类型为 int(*)[5]。</p>
<table>
<tbody>
<tr>
<td>
<p>二维数组</p>
</td>
<td>
<p>含义及类型</p>
</td>
<td>
<p>取地址符(&amp;)</p>
</td>
<td>
<p>sizeof</p>
</td>
</tr>
<tr>
<td>
<p>数组名：a</p>
</td>
<td>
<p>①二维数组名a指向数组首元素的地址，即第1行（a[0]）的地址（注意，不是a[0][0]的地址）。因此，a被称为行指针，指向第1行元素（一维数组）的地址。这个元素的类型是int（*）[5]（即一维数组）。所以a的类型为int(*)[5];a可以看作是行指针，②a + 1表示第二行的指针，a + i表示第i + 1行的指针（也是int(*)[5]类型）&hellip;&hellip;</p>
</td>
<td>
<p>①&amp;a表示整个二维数组的地址，所以&amp;a + 1指向这个二维数组最后一个元素的后面。</p>
</td>
<td>
<p>①sizeof(a)表示整个二维数组的大小。</p>
<p>②sizeof(&amp;a)为指针大小4字节。</p>
<p>③sizeof(*&amp;a)等于sizeof(a)</p>
</td>
</tr>
<tr>
<td>
<p>a[i]</p>
</td>
<td>
<p>①a[i]的类型：如果把二维数组看作是由三个元素（一维数组）组成的数组，那么这三个一维数组的数组名分别为a[0]、a[1]、a[2]。因此，a[0]可以看作是指向第1行（一维数组）首元素（a[0][0]）的地址，a[i]是指向第i + 1行（一维数组）首元素的地址，所以a[i]为int*型。</p>
<p>②a[i] + 1表示这行数组第2个元素的地址，即a[i] + 1是指向a[i][1]元素的地址，*(a[i] + 1)是a[i][1]元素的值。同理，a[i] + j是指向a[i][j]的地址，*(a[i] + j)是a[i][j]的值。</p>
</td>
<td>
<p>&amp;a[i]表示第i + 1行这行整个一维数组的地址。因此，&amp;a[i] + 1是指向这行数组的下一行的指针。</p>
</td>
<td>
<p>①sizeof(a[i])：a[i]是一个一维数组。sizeof(a[i])为这个数组的大小。</p>
<p>②sizeof(&amp;a[i])为指针大小4字节。</p>
<p>③sizeof(*&amp;a[i])等于sizeof(a[i])</p>
</td>
</tr>
<tr>
<td>
<p>a[i][j]</p>
</td>
<td>
<p>与a、a[i]类型的含义不同，a[i][j]不再是一个指针，而是元素的类型，即int型。</p>
</td>
<td>
<p>&amp;a[i][j]表示这个元素的地址，即int*型</p>
</td>
<td>
<p>①sizeof(a[i][j])：a[i][j]表示元素的类型。</p>
<p>②sizeof(&amp;a[i][j])为指针大小。</p>
<p>③sizeof(*&amp;a[i][j])等于sizeof(a[i][j])</p>
</td>
</tr>
<tr>
<td>
<p>备注</p>
</td>
<td colspan="3">
<p>①通常情况下，数组名可看作是首元素的地址，而表格中所说的数组名a、a[i]的类型是指当他们代表各自数组的首元素时的类型。</p>
<p>②但当对数组名取地址符（&amp;）或sizeof时，它不能看作是首元素的地址，而代表的是整个数组。请注意表格中&amp;和sizeof两列的分析。</p>
</td>
</tr>
</tbody>
</table>
<div>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;

int main(int argc,char* argv[], char* env[])<br />
{

    int a[][] = {};<br />
    int c;

    printf("Information for array：a[3][5]：\n");<br />
    printf("a = 0x%08X, a + 1 = 0x%08X, sizeof(a) = %d\n", a, a + , sizeof(a));<br />
    printf("&amp;a = 0x%08X, &amp;a + 1 = 0x%08X, sizeof(&amp;a) = %d, sizeof(*&amp;a) = %d\n",<br />
               &amp;a, &amp;a + , sizeof(&amp;a),sizeof(*&amp;a));

    printf("\n");

    //a[i]指向一个一维数组的首元素，a[i]+1指向该行第2个元素。sizeof(a[i])时不能看成首元素，而是这行整个一维数组<br />
    for(c=;c&lt; ;c++)<br />
    {<br />
      printf("a[%d] = 0x%08X, a[%d] + 1 = 0x%08X, sizeof(a[%d]) = %d,\n",<br />
                c, a[c], c, a[c] + ,c, sizeof(a[c]));<br />
    }

    printf("\n");

    //对a[i]进行&amp;取地址符时，a[i]不能看作这一行的首元素，而是整个一维数组。即&amp;a[i]表示第i+1的整个数组<br />
    //&amp;a[i]+1表示下一行。<br />
for(c=;c&lt; ;c++)<br />
    {<br />
      printf("&amp;a[%d] = 0x%08X, &amp;a[%d] + 1 = 0x%08X, sizeof(&amp;a[%d]) = %d, sizeof(*&amp;a[%d]) = %d\n",<br />
               c, &amp;a[c],c, &amp;a[c] + ,c, sizeof(&amp;a[c]), c, sizeof(*&amp;a[c]));<br />
    }

    return ;<br />
}

/*<br />
输出结果：<br />
Information for array：a[3][5]：<br />
a = 0x0023FE80, a + 1 = 0x0023FE94, sizeof(a) = 60<br />
&amp;a = 0x0023FE80, &amp;a + 1 = 0x0023FEBC, sizeof(&amp;a) = 4, sizeof(*&amp;a) = 60

a[0] = 0x0023FE80, a[0] + 1 = 0x0023FE84, sizeof(a[0]) = 20,<br />
a[1] = 0x0023FE94, a[1] + 1 = 0x0023FE98, sizeof(a[1]) = 20,<br />
a[2] = 0x0023FEA8, a[2] + 1 = 0x0023FEAC, sizeof(a[2]) = 20,<br />
a[3] = 0x0023FEBC, a[3] + 1 = 0x0023FEC0, sizeof(a[3]) = 20,<br />
a[4] = 0x0023FED0, a[4] + 1 = 0x0023FED4, sizeof(a[4]) = 20,

&amp;a[0] = 0x0023FE80, &amp;a[0] + 1 = 0x0023FE94, sizeof(&amp;a[0]) = 4, sizeof(*&amp;a[0]) = 20<br />
&amp;a[1] = 0x0023FE94, &amp;a[1] + 1 = 0x0023FEA8, sizeof(&amp;a[1]) = 4, sizeof(*&amp;a[1]) = 20<br />
&amp;a[2] = 0x0023FEA8, &amp;a[2] + 1 = 0x0023FEBC, sizeof(&amp;a[2]) = 4, sizeof(*&amp;a[2]) = 20<br />
&amp;a[3] = 0x0023FEBC, &amp;a[3] + 1 = 0x0023FED0, sizeof(&amp;a[3]) = 4, sizeof(*&amp;a[3]) = 20<br />
&amp;a[4] = 0x0023FED0, &amp;a[4] + 1 = 0x0023FEE4, sizeof(&amp;a[4]) = 4, sizeof(*&amp;a[4]) = 20<br />
*/</pre>
</div>
<p>(3)二维数元素的访问方式:int a[i][j];</p>
<p>①a[i][j]</p>
<p>②&nbsp;*(*(a + i) + j);//a + i 是第 i+1 行首元素(一维数组)的地址,即保存一个一维数的地址,*(a + i)取出当中保存的一维数组地址。</p>
<p>注意这也是一个地址,而*(a + i)+j 表示在这个一维数组地址基础上加 j 的偏移处,然后*(*(a + I)+ j)取出该元素出来。</p>
<p>动态申请二维数组</p>
<div>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;<br />
#include &lt;malloc.h&gt;

int** malloc2d(int row,int col)<br />
{<br />
    int** ret = NULL;

    if((row &gt;) &amp;&amp; (col &gt;))<br />
    {<br />
        int* p = NULL;

        //先申请第一维数组,用于存放行指针<br />
        ret = (int**)malloc(row * sizeof(int*));

        //再申请整个数组存储空间的大小，用于存放所有元素<br />
        p = (int*)malloc(row * col * sizeof(int));

        //将数组空间分为二维<br />
        if ((ret != NULL) &amp;&amp; (p != NULL))<br />
        {<br />
            int i=;<br />
            for(i=; i&lt;row; i++)<br />
            {<br />
                ret[i] = p + i*col;<br />
            }<br />
        }<br />
        else<br />
        {<br />
            free(ret);<br />
            free(p);

            ret = NULL;<br />
        }<br />
    }

    return ret;<br />
}

void free2d(int** p)<br />
{<br />
    if(*p != NULL) //p指向二维数组<br />
    {<br />
        //*p指向p[0]，而这里保存的即是<br />
        //第1个元素的地址，也是整个数<br />
        //组元素空间地址。<br />
        free(*p);  //释放元素所占空间<br />
    }

    free(p);//释放行指针所占空间<br />
}

int main()<br />
{<br />
    int** a = malloc2d(, );<br />
    int i = ;<br />
    int j = ;

    for(i=; i&lt;; i++)<br />
    {<br />
        for(j=; j&lt;; j++)<br />
        {<br />
            printf("%d, ",a[i][j]);<br />
        }<br />
        printf("\n");<br />
    }

    free2d(a);

    return ;<br />
}</pre>
</div>
<p>无法将指针变量本身传递给一个函数,须传递指针的地址</p>
<div>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;<br />
#include &lt;malloc.h&gt;<br />
#include &lt;string.h&gt;

void GetMemory(char* p,int num)<br />
{<br />
    //由于p是函数参数，当函数返回时，会被释放<br />
    p = (char*)malloc(num*sizeof(char));<br />
}

void GetMemoryEx(char** p,int num)<br />
{<br />
    //p指向一个指针，将该指针的值指向新的开辟的内存空间。<br />
    *p = (char*)malloc(num * sizeof(char));<br />
}

int main()<br />
{<br />
    char* str = NULL;

/*<br />
    //错误的做法<br />
    GetMemory(str,10);//试图让str让指向新开辟的内存空间。因为须改变<br />
                      //指针str的值，所以得传递指针的地址过去。否则<br />
                      //在传参时，GetMemory只是复制str的值过去。即，<br />
                      //将NULL复制给参数。

    strcpy(str,"hello");

    free(str);//free并没有起作用，内存泄漏<br />
*/

    //正确的做法<br />
    GetMemoryEx(&amp;str,);//将str指针的地址传递到函数里，函数内部就<br />
                         //可以改变str指针的值，让其指向新的地址。

    strcpy(str,"hello");

    free(str);//free并没有起作用，内存泄漏

    return ;<br />
}</pre>
</div>
<p>参考资料：<br />www.dt4sw.com<br />http://www.cnblogs.com/5iedu/category/804081.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwvvpy8.html">DBImport v3&period;5 中文版发布：数据库定时同步及文档生成工具（IT人员必备）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jm5je9.html">STM32端口复用和映射</a>
		</li>
						<li><a href="https://www.batexi.com/a/390d0638.html">ajax传递array参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw5n2yq.html">C&sol;C&plus;&plus; 结构体 数组 函数传递</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwedxlq.html">Class&period;isAssignableFrom&lpar;Class clz&rpar;与instanceof与Class&period;isInstance&lpar;Object obj&rpar; 的区别和联系</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jyg1l9.html">css&OpenCurlyDoubleQuote;变形&rdquo;效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xg2ov8.html">github入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjdwy38.html">restlet不能接受angular post过来的数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zl17x9.html">Backbone源码解读（一）事件模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv10r3zq.html">HTML友情链接代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgl3j78.html">Swift中方法闭包参数不能省略括号的一种情况</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j1orv8.html">利用gradle添加构建版本号</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpw5v39.html">Html &vert; Vue &vert; Element UI&mdash;&mdash;引入使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meg120q.html">Java框架中Struts和Struts2框架的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/960344n9.html">C&plus;&plus;&lowbar;调用约束</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25y4ewq.html">使用 PLSQL 提示动态执行表不可访问，本会话的自动统计被禁止</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1wd5xq.html">Python基础【day03】：文件操作（七）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90ro4739.html">IntelliJ IDEA 2017版 spring-boot 2&period;0&period;3 邮件发送搭建&comma;概念梳理 &lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjl67e9.html">Scala&lowbar;基本语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9027rvmq.html">MySql详解（七）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qd51eoz9.html">linux-RabbitMQ安装命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2xewlw9.html">RGB&lpar;16进制&rpar;&lowbar;转&lowbar;TColor</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvdp2ejq.html">SQL Server 性能优化之RML Utilities：快速入门（Quick Start）（1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlodl26q.html">GridRegionAdapter（slivelight）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q445j50q.html">迭代式返回 IEnumerable&amp;lt&semi;T&amp;gt&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96m20en8.html">WCF实现REST服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy2n2wg9.html">release和retain还有多少人在用</a>
			</li>
						<li><a href="https://www.batexi.com/a/90d0d238.html">MySql简单分页存储过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2xemrw9.html">linux monitor and maintanence</a>
			</li>
						<li><a href="https://www.batexi.com/a/q15ojz09.html">剑指offer--14&period;求1&plus;2&plus;3&plus;&period;&period;&period;&plus;n</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
